/*
 * Copyright (c) 2019 Samsung Electronics Co., Ltd All Rights Reserved
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#pragma once

#ifdef __cplusplus
extern "C" {
#endif

#include <glib.h>

#include "alarm.h"
#include "alarm-internal.h"

bool _alarm_set_global_to_db(__alarm_info_t *alarm_info, bool global);
bool _delete_alarms(alarm_id_t alarm_id);
int _get_db_path_for_all_info(uid_t uid, char** db_path);
bool _initialize_db();
void _load_alarms_from_db();
bool _save_alarms(__alarm_info_t *__alarm_info);
bool _update_alarms(__alarm_info_t *__alarm_info);
gboolean _update_relative_alarms(gpointer user_data);
void _update_db_for_disabled_alarm(alarm_id_t alarm_id, bool disabled_by_ups);

#ifdef __cplusplus
}
#endif

