/*
 * Copyright (c) 2019 Samsung Electronics Co., Ltd All Rights Reserved
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef MOCK_ALARM_DBUS_H_
#define MOCK_ALARM_DBUS_H_

#include <glib.h>

#include "mock.h"

DECLARE_FAKE_VALUE_FUNC(gboolean, alarm_manager_call_alarm_get_info_sync,
    AlarmManager*, gint, gint*, gint*, gint*, gint*, gint*, gint*, gint*,
    gint*, gint*, gint*, gint*, gint*, gint*, gint*, GCancellable*, GError**);

DECLARE_FAKE_VALUE_FUNC(gboolean, alarm_manager_call_alarm_create_appsvc_sync,
    AlarmManager*, gint, gint, gint, gint, gint, gint, gint, gint, gint, gint,
    gint, gint, gint, gint, const char*, gint*, gint*, GCancellable*, GError**);

DECLARE_FAKE_VALUE_FUNC(gboolean, alarm_manager_call_alarm_get_appsvc_info_sync,
    AlarmManager*, gint, gchar**, gint*, GCancellable*, GError**);

DECLARE_FAKE_VALUE_FUNC(gboolean, alarm_manager_call_alarm_create_noti_sync,
    AlarmManager*, gint, gint, gint, gint, gint, gint, gint, gint, gint, gint, gint,
    gint, gint, gint, const char*, gint*, gint*, GCancellable*, GError**);

DECLARE_FAKE_VALUE_FUNC(gboolean, alarm_manager_call_alarm_get_noti_info_sync,
    AlarmManager*, gint, gchar**, gint*, GCancellable*, GError**);

DECLARE_FAKE_VALUE_FUNC(gboolean, alarm_manager_call_alarm_set_rtc_time_sync,
    AlarmManager*, gint, gint, gint, gint, gint, gint,  gint*, GCancellable*,
    GError**);

DECLARE_FAKE_VALUE_FUNC(gboolean, alarm_manager_call_alarm_delete_sync,
    AlarmManager*, gint, gint*, GCancellable*, GError**);

DECLARE_FAKE_VALUE_FUNC(gboolean, alarm_manager_call_alarm_delete_all_sync,
    AlarmManager*, gint*, GCancellable*, GError**);

DECLARE_FAKE_VALUE_FUNC(gboolean, alarm_manager_call_alarm_get_number_of_ids_sync,
    AlarmManager*, gint*, gint*, GCancellable*, GError**);

DECLARE_FAKE_VALUE_FUNC(gboolean, alarm_manager_call_alarm_get_list_of_ids_sync,
    AlarmManager*, gint, GVariant**, gint*, gint*, GCancellable*, GError**);

DECLARE_FAKE_VALUE_FUNC(gboolean, alarm_manager_call_alarm_get_next_duetime_sync,
    AlarmManager*, gint, gint*, gint*, GCancellable*, GError**);

DECLARE_FAKE_VALUE_FUNC(gboolean, alarm_manager_call_alarm_create_periodic_sync,
    AlarmManager*, const gchar*, const gchar*, gint, gint, gint, gint*,
    gint*, GCancellable*, GError**);

DECLARE_FAKE_VALUE_FUNC(gboolean, alarm_manager_call_alarm_set_time_sync,
    AlarmManager*, gint, gint*, GCancellable*, GError**);

DECLARE_FAKE_VOID_FUNC(alarm_manager_call_alarm_set_time, AlarmManager*, gint,
    GCancellable*, GAsyncReadyCallback, gpointer);

DECLARE_FAKE_VALUE_FUNC(gboolean, alarm_manager_call_alarm_set_timezone_sync,
    AlarmManager*, const char*, gint*, GCancellable*, GError**);

DECLARE_FAKE_VALUE_FUNC(gboolean,
    alarm_manager_call_alarm_set_time_with_propagation_delay_sync,
    AlarmManager*, guint, guint, guint, guint, gint*, GCancellable*,
    GError**);

DECLARE_FAKE_VOID_FUNC(alarm_manager_call_alarm_set_time_with_propagation_delay,
    AlarmManager*, guint, guint, guint, guint, GCancellable*,
    GAsyncReadyCallback, gpointer);

DECLARE_FAKE_VALUE_FUNC(gboolean, alarm_manager_call_alarm_update_sync,
    AlarmManager*, gint, gint, gint, gint, gint, gint, gint, gint, gint,
    gint, gint, gint, gint, gint, gint, gint*, GCancellable*, GError**);

DECLARE_FAKE_VALUE_FUNC(gboolean, alarm_manager_call_alarm_set_global_sync,
    AlarmManager*, gint, gboolean, gint*, GCancellable*, GError**);

DECLARE_FAKE_VALUE_FUNC(gboolean, alarm_manager_call_alarm_get_global_sync,
    AlarmManager*, gint, gboolean*, gint*, GCancellable*, GError**);

#endif //MOCK_ALARM_DBUS_H_
