/*
 * Copyright (c) 2019 Samsung Electronics Co., Ltd All Rights Reserved
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef MOCK_CYNARA_H_
#define MOCK_CYNARA_H_

#include <cynara-session.h>
#include <cynara-client.h>
#include <cynara-creds-gdbus.h>

#include "mock.h"

DECLARE_FAKE_VALUE_FUNC(int, cynara_initialize, cynara**,
    const cynara_configuration*);
DECLARE_FAKE_VALUE_FUNC(int, cynara_creds_gdbus_get_user, GDBusConnection*,
    const gchar*, enum cynara_user_creds, gchar **);
DECLARE_FAKE_VALUE_FUNC(int, cynara_creds_gdbus_get_client, GDBusConnection*,
    const gchar*, enum cynara_client_creds, gchar **);
DECLARE_FAKE_VALUE_FUNC(char*, cynara_session_from_pid, pid_t);
DECLARE_FAKE_VALUE_FUNC(int, cynara_check, cynara*, const char*, const char*,
    const char*, const char*);


#endif //MOCK_CYNARA_H_
